/* ***** BEGIN LICENSE BLOCK *****
 *   Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Save File to.
 *
 * The Initial Developer of the Original Code is
 * Atte Kemppilä.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 * 
 * ***** END LICENSE BLOCK ***** */


var savefileto_folder =
{
    set result(a) { window.arguments[0].out = a; },
    
    get name()      { return document.getElementById("tbox_name").value; },
    set name(value) { document.getElementById("tbox_name").value = value; },
    
    get path()      { return document.getElementById("tbox_path").value; },
    set path(value) { document.getElementById("tbox_path").value = value; },
    
    get dir()
    {
        try
        {
            var file = savefileto_util.getFile(this.path);
            if (file.exists() && file.isDirectory())
                return file;
        }
        catch (e) { /* ignore */ }
        return null;
    },
    
    doOnLoad: function()
    {
        this.l10n = document.getElementById("l10n");
        var args = window.arguments[0].inn;
        this.setValues(args.name, args.path);
    },
    
    pickFolder: function()
    {
        const nsIFilePicker = Components.interfaces.nsIFilePicker;
        var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
        fp.displayDirectory = this.dir;
        fp.init(window, this.l10n.getString("folderPickerTitle"), nsIFilePicker.modeGetFolder);
        var value = fp.show();
        if (value == nsIFilePicker.returnOK)
            this.setValues(fp.file.leafName, fp.file.path);
    },
    
    setValues: function(name, path)
    {
        this.name = name;
        this.path = path;
    },
    
    doOnDialogAccept: function()
    {
        try
        {
            var name = this.name;
            if (/^\s*$/.test(name))
                throw "err.emptyName";
            if (/^.*[*|].*$/.test(name))
                throw "err.invalidName";
            var path = this.path;
            if (/^\s*$/.test(path))
                throw "err.emptyPath";
            if (! this.dir)
                throw "err.folderNotFound";
            this.result = {name: name, path: path};
            return true;
        }
        catch (e)
        {
            var promptSvc = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
            promptSvc.alert(window, this.l10n.getString("err.title"), this.l10n.getString(e));
            return false;
        }
    }
}
